datablock PlayerData(ConanCakePlayer : PlayerStandardArmor)
{
	shapeFile = "./cake.dts";

	canJet = 0;

	maxForwardCrouchSpeed = 1.6;
	maxSideCrouchSpeed = 2;
	maxBackwardCrouchSpeed = 1.6;

	maxBackwardSpeed = 2.2;
	maxSideSpeed = 2;
	maxForwardSpeed = 2.7;

	uiname = "Conan";
};

function serverCmdCakeLegs(%cl) {
	if (!isObject(%cl.player)) {
		return;
	}
	%bot = new AIPlayer(SupportBots) {
		dataBlock = PlayerStandardArmor;
	};
	%bot.hideNode("ALL");
	%cl.player.setDatablock(ConanCakePlayer);
	%cl.player.hideNode("cake");
	%cl.player.mountObject(%bot);
	%cake = %cl.player;
	%cl.createPlayer(%cake.getTransform());
	%cake.client = "";
	%cake.setShapeNameDistance(0);
	%cake.mountObject(%bot, 10);
	%bot.mountObject(%cl.player, 7);
	%cl.player.hideNode("lShoe"); %cl.player.hideNode("rShoe");
	%cl.player.hideNode("lPeg"); %cl.player.hideNode("rPeg");
	%cl.player.setControlObject(%cake);
	%bot.isLeg = 1;
	%bot.supportBot = %cake;
}

function serverCmdConanJr(%cl) {
	if (!isObject(%cl.player)) {
		return;
	}
	%cl.player.setDatablock(PlayerStandardArmor);
	%legs = %cl.player;
	%legs.isLeg = 1;
	%cl.createPlayer(%legs.getTransform());

	for (%i = 0; %i < 10; %i++) {
		%legs.hideNode($hat[%i]);
		%legs.hideNode($pack[%i]);
		%legs.hideNode($secondpack[%i]);
		%legs.hideNode($chest[%i]);
	}
	%legs.hideNode("lArm"); %legs.hideNode("rArm");
	%legs.hideNode("lArmSlim"); %legs.hideNode("rArmSlim");
	%legs.hideNode("lHand"); %legs.hideNode("rHand");
	%legs.hideNode("lHook"); %legs.hideNode("rHook");
	%legs.hideNode("headSkin");

	%legs.client = "";
	%legs.setShapeNameDistance(0);
	%legs.mountObject(%cl.player, 7);
	%cl.player.setDatablock(ConanCakePlayer);
	%cl.player.setControlObject(%legs);
	%cl.player.playThread(cake);
}

package LegDismount {
   function Player::dismount(%pl, %client) {
      if (%pl.getObjectMount().isLeg) {
         if (isObject(%pl.getObjectMount().supportBot)) {
            %pl.getObjectMount().supportBot.delete();
         }
         %pl.getObjectMount().delete();
      }

      return parent::dismount(%pl, %client);
   }

   function Armor::onDisabled(%this, %pl, %state) {
      if (%pl.getObjectMount().isLeg) {
         if (isObject(%pl.getObjectMount().supportBot)) {
            %pl.getObjectMount().supportBot.delete();
         }
         %pl.getObjectMount().delete();
      }
      return parent::onDisabled(%this, %pl, %state);
   }

   function Armor::onRemove(%this, %pl) {
      if (%pl.getObjectMount().isLeg) {
         if (isObject(%pl.getObjectMount().supportBot)) {
            %pl.getObjectMount().supportBot.delete();
         }
         %pl.getObjectMount().delete();
      }
      return parent::onRemove(%this, %pl);
   }

   function GameConnection::applyBodyParts(%cl) {
      %ret = parent::applyBodyParts(%cl);
      if (isObject(%cl.player) && %cl.player.getObjectMount().isLeg) {
         %cl.player.hideNode("lShoe"); %cl.player.hideNode("rShoe");
         %cl.player.hideNode("lPeg"); %cl.player.hideNode("rPeg");
      }
      return %ret;
   }
};
activatePackage(LegDismount);